# Abstract Data Type
def student(year, major):
    """
    Returns a student that has
    attributes YEAR, MAJOR.
    """
    return [year, major]

def get_year(student):
    """
    returns STUDENT's year.
    """
    return student[0]

def get_major(student):
    """
    returns STUDENT's major.
    """
    return student[0]

###################################
# To interact with student, we    #
# don't need to know how features #
# are structured.                 #
###################################

def mystery():
    student = student(2, "Economics") # create a student
    print(f"This is a year {get_year(student)} \
            studying {get_major(student)}!")
    return 0

#########
# LISTS #
#########


def check_bool():
    lst = []
    print("When I'm empty, I'm... : ", bool(lst))
    print(f"I'm {len(lst)} long.")
    lst = list(range(8)) # Make a list of numbers from 0 to 7
    print(f"I'm {len(lst)} long.")

def indexing():
    lst = list(range(8))
    print("I'm zero-indexed!")
    for i in range(len(lst)):
        print(f"This is element {i} with value {lst[i]}")

    print("When I try to go too far...")
    for j in range(10):
        try:
            lst[j] # access value
            print(f"At index {j}, I still work!")
        except:
            print(f"At index {j}, I don't work :'(")

    print("When I go backwards...")
    for j in range(0, -(len(lst) + 3), -1):
        try:
            lst[j] # access value
            print(f"At index {j}, I still work!")
        except:
            print(f"At index {j}, I don't work :'(")

def slice():
    print("You can make a copy of me... or just parts of me")
    print(">>>lst = [x for x in range(20) if x % 2 == 0]")
    lst = [x for x in range(20) if x % 2 == 0]
    divisible_by_four = lst[::2]
    print(">>>divisible_by_four = lst[::2]")
    print(not_divisible_by_four)
    ten_to_16_exclusive = lst[5:9]
    print(">>>ten_to_16_exclusive = lst[4:8]")
    print(ten_to_16_exclusive)
    exact_copy = lst[:]
    print(">>>exact_copy = lst[:]")
    print(exact_copy)
    lst[0] = 1 # change original list
    print("change doesn't propogate... slicing creates a NEW list.")
    print("original:", lst)
    print("copy:", exact_copy)

    
